<%@page language="java" import="java.util.*,java.text.*, com.homeautomationguru.intellihome.modules.*, com.homeautomationguru.intellihome.helpers.*" %>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<meta name="apple-mobile-webapp-capable" content="yes"/>
	<meta name="apple-mobile-webapp-status-bar-style" content="black-translucent"/>
	
	<link rel="stylesheet" href="/css/jquery.mobile-1.4.2.min.css">
	<link rel="stylesheet" href="/css/prefs.css">
	<link rel="app-touch-startup-image" href="apple-touch-icon.png">
	<script src="/js/jquery.js"></script>
	<script src="/js/jquery.mobile-1.4.2.min.js"></script>
</head> 
<body> 

<!-- page -->
<div id="Preferences" data-role="page" data-title="Preferences">

	<!-- header -->
	<div data-role="header" data-position="fixed" data-fullscreen="true" data-tap-toggle="false" class="ui-header ui-bar-f" role="banner">
		<h1>Preferences</h1>
		<a href="/action" data-ajax="false" data-direction="reverse" data-icon="home" data-iconpos="notext" data-shadow="true">Back</a>
	</div>
	<!-- /header -->

	<div data-role="panel" id="panelprefs"  data-display="push" data-dismissible="false"> 
			<a onClick="return showPanel('summary');" id='menu-summary' data-rel='popup' data-role='button' class="greyButton">Summary</a>
			<a onClick="return showPanel('isy');" id='menu-isy' data-rel='popup' data-role='button'>ISY</a>
			<a onClick="return showPanel('weather');"  id='menu-weather' data-rel='popup' data-role='button'>Weather</a>
			<a onClick="return showPanel('blueiris');"  id='menu-blueiris' data-rel='popup' data-role='button'>Blue Iris</a>
			<a onClick="return showPanel('moves');"  id='menu-moves' data-rel='popup' data-role='button'>Moves App</a>
			<a onClick="return showPanel('sitesage');"  id='menu-sitesage' data-rel='popup' data-role='button'>SiteSage</a>
			<a onClick="return showPanel('ithermostat');"  id='menu-ithermostat' data-rel='popup' data-role='button'>Insteon Thermostats</a>
			<a onClick="return showPanel('nthermostat');"  id='menu-nthermostat' data-rel='popup' data-role='button'>Nest Thermostats</a>
			<a onClick="return showPanel('slideshow');"  id='menu-slideshow' data-rel='popup' data-role='button'>Slide Show</a>
			<br/><br/>
			<a onClick="$('#prefsform').submit();" class="blueButton" id='form-submit' data-rel='popup' data-ajax="false" data-role='button'>Save</a>
	</div>

	<!-- content -->
	<div data-role="content" class="ui-content" role="main" style="width:800px">
	<form id="prefsform" action="/action?action=setprefs" method=get>

		<div class="content-primary" id="summary" style="display:block"><br/>
			<h3>Database</h3>
			<div>The database is at: <%=InitializationManager.getDBPath() %></div>

			<h3>File Paths</h3>
			<div>Some features of Intellihome (such as downloading weather and location data) will download temporary files to disk.</div>
			<div>The paths here specify where the data is downloaded, and then where it should be moved after it's processed (or failed processing)</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Data Path</td><td>The location temporary files are stored before processing<td><%=InitializationManager.getDataPath()%></td></tr>
				<tr><td align="right">Data Archive Path</td><td>The location temporary files are moved when successfully processed<td><%=InitializationManager.getDataCompletePath()%></td></tr>
				<tr><td align="right">Data Error Path</td><td>The location temporary files are moved when processing fails<td><%=InitializationManager.getDataErrorPath()%></td></tr>
			</table>
			
		</div>

		<div class="content-primary" id="isy" style="display:none"><br/>
			<h3>ISY Configuration</h3>
			<div>These values are used to connect to your ISY-994i.</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">ISY User Name</td><td>ISY User Name<td><input type="text" name="isy.username" value="<%=PrefsHelper.getStringPreference("isy.username")%>"></td></tr>
				<tr><td align="right">ISY Password</td><td>ISY Password<td><input type="password" name="isy.password" value="<%=PrefsHelper.getStringPreference("isy.password")%>"></td></tr>
				<tr><td align="right">ISY UUID</td><td>This is the uuid of your ISY device, in the form nn:nn:nn:nn:nn:nn.  The UUID can be found in help:about in the ISY Administrative Console.<td><input type="text" name="isy.uuid" value="<%=PrefsHelper.getStringPreference("isy.uuid")%>"></td></tr>
				<tr><td align="right">ISY IP</td><td>this is the IP address and port of your ISY device, including port (i.e., http://nnn.nnn.nnn.nnn:pppp/)<td><input type="text" name="isy.ip" value="<%=PrefsHelper.getStringPreference("isy.ip")%>"></td></tr>
				<tr><td align="right">Use UPNP?</td><td>Set this value to 0; UPNP not currently supported<td><input type="text" name="isy.useupnp" value="<%=PrefsHelper.getStringPreference("isy.useupnp")%>"></td></tr>
			</table>
		</div>

		<div class="content-primary" id="weather" style="display:none"><br/>
			<h3>Weather Configuration</h3>
			<div>Weather configuration is periodically downloaded to the database.  Specify a URL to get the weather information from http://www.worldweatheronline.com/.</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Weather URL</td><td>Weather URL.  You can leave the string as-is, but update the zip code in the URL to your ZIP code.<td><input type="text" name="datasaver.weather.baseURL" value="<%=PrefsHelper.getStringPreference("datasaver.weather.baseURL")%>"></td></tr>
			</table>
		</div>

		<div class="content-primary" id="blueiris" style="display:none"><br/>
			<h3>Blue Iris Configuration</h3>
			<div><a target=_new href="http://homeautomationguru.com/blue-iris-a-must-have-for-foscam-cameras/">Blue Iris</a> integration allows you to use the <a target=_new href="http://homeautomationguru.com/isy994i-network-module/">ISY Network Module</a>
			to grab pictures from a predefined security camera and save them locally for viewing (i.e., when a doorbell is rung, or at a certain time of day).</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Image Capture URL</td><td>This is the URL of the camera image. xx represents the IP address of the Blue Iris Server, and yyy represents the short name of the camera.<br/>You should test this by opening a web browser and entering the URL; you should see a JPG of the camera's view.<br/>(ex: http://xx.xx.xx.xx/image/yyy)<td><input type="text" name="image.capture.url" value="<%=PrefsHelper.getStringPreference("image.capture.url")%>"></td></tr>
				<tr><td align="right">Image Save Folder</td><td>This is the folder where the images will be saved. If you used the default path, this should be fine, but make sure the folder exists.<br/>(ex: E:\\intellihome\\data\\capturedimages\\)<td><input type="text" name="image.save.folder" value="<%=PrefsHelper.getStringPreference("image.save.folder")%>"></td></tr>
				<tr><td align="right">Image Load URL</td><td>This is the URL that your browser will use to access the images through Intellihome. Note that it's using the Tomcat port, not the Blue Iris port,<br/>because it will be displaying the archived images that have been captured.<br/>(ex: http://xxx.xxx.xx.xx:8080/data/capturedimages/).<td><input type="text" name="image.load.url" value="<%=PrefsHelper.getStringPreference("image.load.url")%>"></td></tr>
				<tr><td align="right">Image Count</td><td>When a signal is sent to capture images, this is the number of images captured.<td><input type="text" name="image.count" value="<%=PrefsHelper.getStringPreference("image.count")%>"></td></tr>
				<tr><td align="right">Image Delay</td><td>When a request is made to capture images, this is the delay between each captured image. For example, if the default values of 5 and 2 are used for count<br/> and delay, respectively, there will be 5 pictures captured over a 10 second period.<td><input type="text" name="image.delay" value="<%=PrefsHelper.getStringPreference("image.delay")%>"></td></tr>
				<tr><td align="right">Image File Prefix</td><td>This is reserved for future use. In the event that multiple camera support is eventually added, each saved image will get its own file name prefix.<td><input type="text" name="image.file.prefix" value="<%=PrefsHelper.getStringPreference("image.file.prefix")%>"></td></tr>
			</table>
		</div>

		<div class="content-primary" id="moves" style="display:none"><br/>
			<h3>Moves App Configuration</h3>
			<div>Your location data can be downloaded to the database periodically via the <a target=_new href="http://homeautomationguru.com/moves-personal-activity/">Moves App</a>. <br/>To get the coordinates for your home, use <a target=_new href="https://www.google.com/maps/">Google Maps</a>, right-click on your home, and select "What's Here?".  A popup will appear showing the latitude and longitude</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Home Latitude</td><td>Your Home Latitude<td><input type="text" name="home.latitude" value="<%=PrefsHelper.getStringPreference("home.latitude")%>"></td></tr>
				<tr><td align="right">Home Longitude</td><td>Your Home Longitude<td><input type="text" name="home.longitude" value="<%=PrefsHelper.getStringPreference("home.longitude")%>"></td></tr>
				<tr><td align="right">Moves API URL</td><td>The address to connect to the Moves API<td><input type="text" name="datasaver.moves.baseURL" value="<%=PrefsHelper.getStringPreference("datasaver.moves.baseURL")%>"></td></tr>
				<tr><td align="right">Moves Access Token</td><td>Your moves access token ( see <a target=_new href="https://dev.moves-app.com/docs/authentication">here</a>)<td><input type="text" name="datasaver.moves.accessToken" value="<%=PrefsHelper.getStringPreference("datasaver.moves.accessToken")%>"></td></tr>
			</table>
		</div>

		<div class="content-primary" id="sitesage" style="display:none"><br/>
			<h3>SiteSage Configuration</h3>
			<div>Your power usage metrics can be downloaded to the database periodically via the <a target=_new href="http://homeautomationguru.com/emonitor/"> SiteSage (eMonitor)</a>.</div>
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">eMonitor NumChannels</td><td>The number of channels in your SiteSage device<td><input type="text" name="powertracker.numchannels" value="<%=PrefsHelper.getStringPreference("powertracker.numchannels")%>"></td></tr>
				<tr><td align="right">eMonitor URL</td><td>The IP address of your SiteSage device (i.e., http://nnn.nnn.nnn.nnn/data.xml?podID=0<td><input type="text" name="powertracker.url" value="<%=PrefsHelper.getStringPreference("powertracker.url")%>"></td></tr>
			</table>
		</div>

		<div class="content-primary" id="ithermostat" style="display:none"><br/>
			<h3>Insteon Thermostat Configuration</h3>
			TBD...
		</div>

		<div class="content-primary" id="nthermostat" style="display:none"><br/>
		
<script>
processNest = function() {
	var pin = document.getElementById('nest-pin').value;
	if (pin.length == 0) {
		alert("You must enter a pin in the field");
		return;
	}
	document.getElementById('nest-code').value = pin;
	document.getElementById('nest-form').submit();
}
</script>	
			<h3>Nest Thermostat Configuration</h3>
			<div><ol><li style="padding-bottom:10px;">In order to authorize the Nest API, you'll need a PIN code from Nest.  You can get that by signing in <a target=_new href="https://home.nest.com/login/oauth2?client_id=b9902519-90d8-4e00-8ce7-eb8ad2eb1be2&state=INTELLIHOME">directly to Nest here</a>, and accepting access (which can be revoked at any time with your Nest App).</li>
			<li style="padding-bottom:10px;">Once you have the PIN code, enter it here: <input id="nest-pin" type="text"></li>
			<li style="padding-bottom:10px;">Click <a target=# onClick="processNest(); return false;">here</a> to generate the Nest URL.  The result that comes back should look something like this:
			<div>{"access_token":"c.5zVeadsfDJasdfAK7asefFaE7afe3cgAafeOSh2t5Yfawewa5ef4aw6e5f5aw56345456231ObX4U8OODXbQdretQsLUqD6V5QjzAinVs","expires_in":315360000}</div></li>
			<li style="padding-bottom:10px;">Copy the access token value (including the "c." part) and paste it in the "Nest Authentication Key" field below.</li> 			
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Nest API URL</td><td>The URL for the Nest API.  You can leave the default.<td><input type="text" name="nest.api-url" value="<%=PrefsHelper.getStringPreference("nest.api-url")%>"></td></tr>
				<tr><td align="right">Nest Authentication Key</td><td>This is the auth code generated with the above steps.  It should be auto-populated with the correct value if you entered the correct PIN.<td><input type="text" name="nest.api-auth" value="<%=PrefsHelper.getStringPreference("nest.api-auth")%>"></td></tr>
				<tr><td align="right">Nest Debug</td><td>Enables debugging of the Nest API.  You can leave it 0 or turn this on with 1.<td><input type="text" name="nest.debug" value="<%=PrefsHelper.getStringPreference("nest.debug")%>"></td></tr>
			</table>
			<li>Finally, see the /WEB-INF/classes/com/homeautomationguru/intellihome/intellihome.properties file to configure the Nest values that will correspond to ISY state variables.
			</ol>
			</div>.
		</div>

		<div class="content-primary" id="slideshow" style="display:none"><br/>
			<h3>Slide Show</h3>
			<!-- <div>Slide Show Settings</div>  -->
			<table border=1 padding=5 cellpadding=5 cellspacing=3>
				<tr><th align="center">Setting</th><th>Description</th><th width="300px">Value</th></tr>
				<tr><td align="right">Folder</td><td>The folder where your slide shows exist.<br/>Each "show" should be in its own folder.<td><input type="text" name="slideshow.folder" value="<%=PrefsHelper.getStringPreference("slideshow.folder","")%>"></td></tr>
				<tr><td align="right">Domain</td><td>If connecting to a UNC path, the domain name to use for the connection.<td><input type="text" name="slideshow.domain" value="<%=PrefsHelper.getStringPreference("slideshow.domain","")%>"></td></tr>
				<tr><td align="right">User Name</td><td>If connecting to a UNC path, the user name to use for the connection.<td><input type="text" name="slideshow.username" value="<%=PrefsHelper.getStringPreference("slideshow.username","")%>"></td></tr>
				<tr><td align="right">Password</td><td>If connecting to a UNC path, the password to use for the connection.<td><input type="text" name="slideshow.password" value="<%=PrefsHelper.getStringPreference("slideshow.password","")%>"></td></tr>
				<tr><td align="right">Interval</td><td>The number of seconds each image is shown<td><input type="text" name="slideshow.interval" value="<%=PrefsHelper.getStringPreference("slideshow.interval","5")%>"></td></tr>
			</table>
		</div>

	</form>
	</div>
	<!-- content -->

</div>
<!-- /page -->

<form method="POST" id="nest-form" target=_new action="https://api.home.nest.com/oauth2/access_token">
<input type="hidden" name="client_id" value="b9902519-90d8-4e00-8ce7-eb8ad2eb1be2" />
<input type="hidden" name="client_secret" value="CJLiWPHFUy6En8EkDSalIytEv" />
<input type="hidden" name="grant_type" value="authorization_code" />
<input type="hidden" id="nest-code" name="code" value="" />
<input type="submit"  />
</form>


<script>
$( document ).one( "pagecreate", function() {
	$("#panelprefs").panel( "open", "" );
});

function showPanel( panelname) {
	// hide all but selected
	$("#summary").hide();
	$("#isy").hide();
	$("#weather").hide();
	$("#blueiris").hide();
	$("#moves").hide();
	$("#sitesage").hide();
	$("#ithermostat").hide();
	$("#nthermostat").hide();
	$("#slideshow").hide();
	$("#"+panelname).show();

	// unhighlight all but selected
	$("#menu-summary").removeClass("greyButton");
	$("#menu-isy").removeClass("greyButton");
	$("#menu-weather").removeClass("greyButton");
	$("#menu-blueiris").removeClass("greyButton");
	$("#menu-moves").removeClass("greyButton");
	$("#menu-sitesage").removeClass("greyButton");
	$("#menu-ithermostat").removeClass("greyButton");
	$("#menu-nthermostat").removeClass("greyButton");
	$("#menu-slideshow").removeClass("greyButton");

	$("#menu-"+panelname).addClass("greyButton");
	return false;
}
</script>

</body>
</html>